#! /bin/bash
name=kelp
version=5.1
	echo -e "\n\n %name-JBuilder8-%version post installation script\n\n"
	default_jdkdir=/usr/java/j2sdk1.4.0_01
	JDK_HOME=${JDK_HOME:=$JAVA_HOME}
        while
                err=0
                if
                        [ X$JDK_HOME = X ]
                then
                        text="Warning: JDK_HOME is not defined."
                        err=1
                elif
                        [ ! -d $JDK_HOME ]
                then
                        text="Warning: No such directory: $JDK_HOME."
                        err=1
                elif
                        [ ! -r $JDK_HOME/bin/javac ]
                then
                        text="Warning: Not valid directory (no javac file): $JDK_HOME."
                        err=1
                fi
                [ $err -gt 0 ]
        do
                echo $text
                echo -e "\n\nPlease enter path to your "\
                        "Java Development Kit - JDK directory [$default_jdkdir] \c"
                read JDK_HOME </dev/tty
                JDK_HOME=${JDK_HOME:=$default_jdkdir}
        done
        export JDK_HOME
	PATH=$JDK_HOME/bin:$PATH
	export PATH
        tools=$(find $JDK_HOME -name tools.jar -print)
        if
                echo $CLASSPATH | grep -v $tools
        then
                CLASSPATH=$CLASSPATH:$tools
                export CLASSPATH
        fi
	
	default_enhdir=/usr/local/enhydra5.1
        while
                echo -e "\n\nPlease enter path to your "\
                        "Enhydra root directory [$default_enhdir] \c"
                read enhdir </dev/tty
                enhdir=${enhdir:=$default_enhdir}
                [ ! -d $enhdir ]
        do
                echo "Warning: No such directory: $enhdir"
        done
	default_jbdir8=/opt/JBuilder8
        while
                echo -e "\n\nPlease enter path to your "\
                        "JBuilder8 root directory [$default_jbdir8] \c"
                read jbdir8 </dev/tty
                jbdir8=${jbdir8:=$default_jbdir8}
                [ ! -d $jbdir8 ]
        do
                echo "Warning: No such directory: $jbdir8"
        done
	major_version=$(echo %version| cut -f1 -d'.')
	kelpdir=${jbdir8}
	if
		[ -f ${kelpdir}/lib/KelpAntCore.jar ]
	then
		echo "Kelp has already been installed, reverting jbuilder.config"
		if 
			[ -f  ${jbdir8}/bin/jbuilder.config.save ]
		then
			mv -f ${jbdir8}/bin/jbuilder.config.save  ${jbdir8}/bin/jbuilder.config
		fi
	fi
	cd $(dirname $0)
	cp -r %name-%version/JBuilder8/* ${kelpdir}
	cd ${kelpdir}
	mv configure* dist
	if
		./dist/configure $jbdir8 $enhdir $JDK_HOME
	then
		echo -e "\n\nThe installation has been successful"
		rm -fr dist
	else
		echo -e "\n\nThe installation failed"
		exit 1
	fi
