/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 */

package org.enhydra.kelp.common.importer;

// Kelp imports
import org.enhydra.kelp.common.Constants;

// Standard imports
import java.io.FileFilter;
import java.io.File;

public class MakefileFilter implements FileFilter {

    /**
     * Creates an extension file filter without an extensions set.
     */
    public MakefileFilter() {}

    /**
     * Return true if this file should be shown in a file chooser.
     */
    public boolean accept(File f) {
        boolean acceptFile = false;
	if (f == null) {
           acceptFile = true;
        } else if (f.isDirectory()) {
	   acceptFile = true;
        } else {
           String lowPath = f.getAbsolutePath().toLowerCase();
           acceptFile = lowPath.endsWith(File.separator + Constants.FILE_MAKEFILE) ||
                        lowPath.endsWith(File.separator + Constants.FILE_CONFIG_MK);

	 }
	return acceptFile;
    }

}
