/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Lisa Reese
 *
 */

package org.enhydra.kelp.forte.node;


import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import org.openide.TopManager;
import org.openide.filesystems.FileObject;
import org.openide.filesystems.FileSystem;
import org.openide.windows.InputOutput;
import org.openide.nodes.*;
import org.openide.TopManager;
import org.openide.loaders.DataFolder;
import org.openide.DialogDescriptor;
import org.enhydra.kelp.forte.services.XMLCCompilerSupport;
import org.openide.loaders.CompilerSupport;
import org.openide.cookies.*;
import org.openide.loaders.*;
import java.net.URL;
import java.io.File;



public class Empty
{
    protected static PrintWriter pw;
    public static void main (String[] args) throws Exception
    {
        InputOutput io = TopManager.getDefault ().getIO ("NodeExp Results");
        io.select ();
        pw = io.getOut();
        pw.println("starting test");


        Node desktopNode = TopManager.getDefault().getPlaces().nodes().projectDesktop();
        Node.Cookie cookie = desktopNode.getCookie(ProjectCookie.class);

        if (cookie != null && cookie instanceof ProjectCookie)
            pw.println("cookie on project Desktop");
        pw.println("DesktopNode name:  " + desktopNode.getDisplayName());

        Children kids = desktopNode.getChildren();
        Enumeration nodes = kids.nodes();
        while (nodes.hasMoreElements())
        {
            Node nextNode = (Node)nodes.nextElement();
            DataObject dob = (DataObject)nextNode.getCookie(DataObject.class);
            if (dob instanceof DataShadow)
                dob = ((DataShadow)dob).getOriginal();
//            pw.println(dob.toString());
            if (dob != null)
                readFiles(dob.getPrimaryFile());
        }
 
        pw.println ("Done.");
    }
    
    protected static void readNodes(Node container)
    {
        Node[] children = container.getChildren().getNodes();
        pw.println("reading node: " + container.getName() + " num children: " + children.length);        
            for (int i = 0; i < children.length; i++)
            { 
                DataObject dob = (DataObject)children[i].getCookie(DataObject.class);
//                if (dob != null)// && (dob instanceof XMLCDataObject) )
//                {
  //                pw.println("XMLC Object found: " + children[i].getName());
 //               }
                        
                    
                if ((dob != null) && (dob instanceof DataFolder) )
                    readNodes(children[i]);

            }
    }
    
    protected static void readFiles(FileObject container)
    {
        FileObject[] children = container.getChildren();
        pw.println("reading node: " + container.getName() + " num children: " + children.length);        
            for (int i = 0; i < children.length; i++)
            {   
                if (children[i].isData())
                {
                    if (children[i].getExt().equals("html"))
                    {
                        pw.println("HTML FOUND: " + children[i].getPackageName('/'));
                        try
                        {
                            DataObject dob = DataObject.find(children[i]);
                            pw.println("data object found...class is: " + dob.getClass().toString());
                        }
                        catch(DataObjectNotFoundException e) {
                            pw.println(e);
                        }
                    }
                    
                }
                        
                    
                else if (children[i].isFolder())
                    readFiles(children[i]);

            }
    }
}
