package org.enhydra.kelp.forte.services;

import java.awt.Image;
import java.beans.*;

import org.openide.execution.ProcessExecutor;
import org.openide.util.NbBundle;

/** Description of the executor.
 *
 * @author root
 */
public class KelpExecutorBeanInfo extends SimpleBeanInfo {

    // Inherit properties and so on from ProcessExecutor.
    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            return new BeanInfo[] {
                       Introspector.getBeanInfo (ProcessExecutor.class)
                   };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }

    public BeanDescriptor getBeanDescriptor () {
        // Here is where to include a customizer class if you have one:
        BeanDescriptor desc = new BeanDescriptor (KelpExecutor.class);
        // Display name also serves as default for instances:
        desc.setDisplayName (NbBundle.getMessage (KelpExecutorBeanInfo.class, "LBL_executor"));
        desc.setShortDescription (NbBundle.getMessage (KelpExecutorBeanInfo.class, "HINT_executor"));
        return desc;
    }

    public PropertyDescriptor[] getPropertyDescriptors () {
        try {
            PropertyDescriptor valueOfMyOption = new PropertyDescriptor ("valueOfMyOption", KelpExecutor.class);
            valueOfMyOption.setDisplayName (NbBundle.getMessage (KelpExecutorBeanInfo.class, "PROP_valueOfMyOption"));
            valueOfMyOption.setShortDescription (NbBundle.getMessage (KelpExecutorBeanInfo.class, "HINT_valueOfMyOption"));
            return new PropertyDescriptor[] { valueOfMyOption };
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }

    private static Image icon, icon32;
    public Image getIcon (int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            if (icon == null)
                icon = loadImage ("enhydraObject.gif");
            return icon;
        } else {
            if (icon32 == null)
                icon32 = loadImage ("enhydraObject32.gif");
            return icon32;
        }
    }

}
