/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Lisa Reese
 *
 */

package org.enhydra.kelp.forte;

import java.awt.Image;
import java.awt.Component;
import java.beans.*;
import java.util.ResourceBundle;
import javax.swing.JFileChooser;

import org.enhydra.tool.common.IconSet;

import org.openide.util.NbBundle;

/** Description of {@link XMLCSettings}.
 *
 * @author rees0234
 */
public class XMLCSettingsBeanInfo extends SimpleBeanInfo {

    private static final ResourceBundle bundle = NbBundle.getBundle(XMLCSettingsBeanInfo.class);
    
    public BeanDescriptor getBeanDescriptor()
    {
        return new BeanDescriptor(XMLCSettings.class, XMLCSettingsCustomizer.class);
    }

    public PropertyDescriptor[] getPropertyDescriptors () {
        try {

//            PropertyDescriptor build = new PropertyDescriptor ("Build", XMLCSettings.class);
//            build.setDisplayName (NbBundle.getMessage (XMLCSettingsBeanInfo.class, "XMLC_BUILD"));
//            build.setShortDescription (NbBundle.getMessage (XMLCSettingsBeanInfo.class, "HINT_build"));
//            build.setPropertyEditorClass(BoolEd.class);

            PropertyDescriptor root = new PropertyDescriptor ("Root", XMLCSettings.class);
            root.setDisplayName (NbBundle.getMessage (XMLCSettingsBeanInfo.class, "PROP_enhydra.xmlc.project.root"));
            root.setShortDescription (NbBundle.getMessage (XMLCSettingsBeanInfo.class, "HINT_enhydra.xmlc.project.root"));
            root.setPropertyEditorClass(DirEd.class);

            PropertyDescriptor source = new PropertyDescriptor ("Source", XMLCSettings.class);
            source.setDisplayName (NbBundle.getMessage (XMLCSettingsBeanInfo.class, "PROP_enhydra.xmlc.src.dir"));
            source.setShortDescription (NbBundle.getMessage (XMLCSettingsBeanInfo.class, "HINT_enhydra.xmlc.src.dir"));
            source.setPropertyEditorClass(DirEd.class);
                        
            return new PropertyDescriptor[] {root, source};
        } catch (IntrospectionException ie) {
            if (Boolean.getBoolean ("netbeans.debug.exceptions"))
                ie.printStackTrace ();
            return null;
        }
    }

    private static Image icon, icon32;
    public Image getIcon (int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            if (icon == null)
                icon = loadImage("enhydraObject.gif");
            return icon;

        } else {
            if (icon32 == null)
                icon32 = loadImage("enhydraObject32.gif");
            return icon32;

        }
    }

    public static class DirEd extends PropertyEditorSupport {
        
        public boolean supportsCustomEditor()
        {
            return true;
        }
        
        public Component getCustomeEditor()
        {
            return new JFileChooser();
        }
    }
/*        public String getAsText () {
            return tags[((Boolean) getValue ()).booleanValue () ? 0 : 1];
        }

        public void setAsText (String text) throws IllegalArgumentException {
            if (tags[0].equals (text))
                setValue (Boolean.TRUE);
            else if (tags[1].equals (text))
                setValue (Boolean.FALSE);
            else
                throw new IllegalArgumentException ();
        }*/

/*    public static class BoolEd extends PropertyEditorSupport {

        private static final String[] tags = {
            NbBundle.getMessage (XMLCSettingsBeanInfo.class, "LBL_true"),
            NbBundle.getMessage (XMLCSettingsBeanInfo.class, "LBL_false")
	};

        public String[] getTags () {
            return tags;
        }

        public String getAsText () {
            return tags[((Boolean) getValue ()).booleanValue () ? 0 : 1];
        }

        public void setAsText (String text) throws IllegalArgumentException {
            if (tags[0].equals (text))
                setValue (Boolean.TRUE);
            else if (tags[1].equals (text))
                setValue (Boolean.FALSE);
            else
                throw new IllegalArgumentException ();
        }

    }*/
}
