package org.enhydra.kelp.ant.deployer;
//Kelp
import org.enhydra.kelp.common.*;
import org.enhydra.kelp.common.event.WriteListener;
import org.enhydra.kelp.ant.AntFacade;

//Toolbox
import org.enhydra.tool.common.ToolException;

//java
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.InputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import org.enhydra.kelp.ant.node.AntProject;
import java.io.FileWriter;
import java.io.BufferedWriter;
import java.util.Date;
import org.enhydra.kelp.ant.ErrorReader;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Damir Milovic
 * @version 1.0
 */

public class AntDeployBuilder extends AbstractEchoBuilder {

  public AntDeployBuilder() {
      super(null);
  }

  public AntDeployBuilder(WriteListener listener) {
      super(listener);
  }

  public AntDeployBuilder(WriteListener listener, boolean buffer) {
      super(listener, buffer);
  }

  public AntDeployBuilder(WriteListener[] listeners) {
    super();
    for (int i = 0; i < listeners.length; i++) {
      addWriteListener(listeners[i]);
    }
  }

  //Implementation
  protected void buildImpl() throws org.enhydra.tool.common.ToolException {
    File root = new File(getProject().getWorkingPath());
    try{
      String enhydraDir = getProject().getProperty(AntProject.ENHYDRA_DIR);
      String execLine = enhydraDir + "/bin/ant";
      if (System.getProperty("os.name").toLowerCase().startsWith("windows")) {
          execLine += ".bat";
      }
      Process process = Runtime.getRuntime().exec(execLine + " deploy", null, root);

          InputStream inputStream = process.getInputStream();
          InputStream errorStream = process.getErrorStream();
          BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
          BufferedReader errorBufferedReader = new BufferedReader(new InputStreamReader(errorStream));
          // init log (ouput) file:
          File logFile = null;
          FileWriter logFileWriter = null;
          BufferedWriter logBuffer = null;
          PrintWriter logPrint = null;
          boolean logFileOK = false;
          String logFileName = ((AntProject)getProject()).getOutputFilename();
          if (logFileName != null) {
            logFile = new File(logFileName);
          }
          if ((logFile != null) && (!logFile.isDirectory())
                && ((AntProject)getProject()).isOutputFileEnabled()) {
              if (logFile.length() > 1e6) {
                  logFileWriter = new FileWriter(logFile, false /* overwrite */ );
              } else {
                  logFileWriter = new FileWriter(logFile, true /* append */ );
              }
              logBuffer = new BufferedWriter(logFileWriter, 4096);
              logPrint = new PrintWriter(logBuffer, false /* auto flush */);
              logPrint.println("------------------------------ "+(new Date()).toString()+" ----------------------");
              logFileOK = true;
          }

          String s = null;

          (new ErrorReader(errorBufferedReader,this,logPrint)).start();


        while((s = bufferedReader.readLine()) != null){
            if(s != null){
              getEchoWriter().println(s);
              if (logFileOK) {
                  logPrint.println(s);
              }
              s = null;
            }
        }

          process.waitFor();
          int k = process.exitValue();
          if (logFileOK) {
              logPrint.flush();
              logPrint.close();
          }

    }catch(Exception e){
      throw new ToolException(e,"Deployer error: "+e.toString());
    }
  }

}