package org.enhydra.kelp.ant.deployer;

import java.awt.*;
import org.enhydra.tool.swing.layout.*;
//import com.borland.jbcl.layout.*;
import javax.swing.*;
import java.util.ResourceBundle;
import org.enhydra.kelp.common.node.OtterFileNode;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.ant.node.AntProject;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class AntDeployInputTemplatesPanel extends JPanel {
  static ResourceBundle res = ResourceBundle.getBundle(
                            "org.enhydra.kelp.common.Res");

    XYLayout xYLayout1 = new XYLayout();
    JLabel jLabelAreaHeader = new JLabel();
    JScrollPane jScrollDocuments = new JScrollPane();
    JList jListDocuments = new JList();
    JCheckBox jCheckFullPath = new JCheckBox();
    JLabel jLabelRoot = new JLabel();
    JTextField jTextFieldRoot = new JTextField();
    JButton jButtonBrowse = new JButton();
    private LocalCheckListener checkListener = null;
    private DefaultListModel modelAvailable = new DefaultListModel();
    private OtterFileNode[] nodes = new OtterFileNode[0];
    private AntProject project = null;

    public AntDeployInputTemplatesPanel() {
        try {
            jbInit();
            pmInit();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }
    void jbInit() throws Exception {
        jLabelAreaHeader.setText(res.getString("Input_documents"));
        this.setLayout(xYLayout1);
        jCheckFullPath.setToolTipText("");
        jCheckFullPath.setText(res.getString("Show_full"));
        xYLayout1.setWidth(472);
        xYLayout1.setHeight(287);
        jLabelRoot.setText(res.getString("Input_root"));
        jButtonBrowse.setText(res.getString("Browse"));
        jButtonBrowse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonBrowse_actionPerformed(e);
            }
        });
        this.add(jLabelAreaHeader,     new XYConstraints(12, 7, 107, 22));
        this.add(jScrollDocuments,  new XYConstraints(12, 37, 448, 119));
        this.add(jCheckFullPath,  new XYConstraints(12, 171, 129, -1));
        this.add(jLabelRoot,  new XYConstraints(12, 206, 65, -1));
        this.add(jTextFieldRoot, new XYConstraints(75, 204, 288, -1));
        this.add(jButtonBrowse, new XYConstraints(374, 203, 83, 23));
        jScrollDocuments.getViewport().add(jListDocuments, null);
    }

    private void pmInit() {
        checkListener = new LocalCheckListener();
        jTextFieldRoot.setEditable(false);	//Do not allow manual changes, use browse button only
        jCheckFullPath.addActionListener(checkListener);
        jCheckFullPath.setSelected(false);
        jListDocuments.setModel(getModelAvailable());
    }

    protected DefaultListModel getModelAvailable() {
        return modelAvailable;
    }

    protected void fillLists() {
        int           count = getNodes().length;
        OtterFileNode source = null;

        if (getModelAvailable().getSize() > 0) {
            getModelAvailable().clear();
        }

        for (int i = 0; i < count; i++) {
            LocalListNode listNode = null;
            source = getNodes()[i];
            listNode = new LocalListNode(source.getFilePath());
            getModelAvailable().addElement(listNode);
        }
    }

    public OtterFileNode[] getNodes() {
        return nodes;
    }

    public void setNodes(OtterFileNode[] n) {
        nodes = n;
        fillLists();
    }

    public void setProject(OtterProject otterProject){
        if(otterProject instanceof AntProject) {
            project = (AntProject) otterProject;
            initOptions();
        }
        else
            System.err.println("DEBUG project must be AntProject");//FIXME throw Exception
    }

    private void initOptions(){
        this.setNodes(project.getAllInput());
        jTextFieldRoot.setText(project.getProperty(AntProject.INPUT_DIR));

//        HashMap replacementsMap = project.getReplacements();
//        Iterator replacementsIterator = replacementsMap.entrySet().iterator();
//        defaultTable = new String[replacementsMap.size()][2];
//        int i = 0;
//        Map.Entry mapEntry = null;
//        while (replacementsIterator.hasNext()) {
//            mapEntry = (Map.Entry)replacementsIterator.next();
//            defaultTable[i][0] = (String)mapEntry.getKey();
//            defaultTable[i][1] = (String)mapEntry.getValue();
//            i++;
//        }
//        setReplacementTable(defaultTable);
    }

    void jButtonBrowse_actionPerformed(ActionEvent e) {
        browseForDir();
    }

    private void browseForDir() {
        JFileChooser    chooser;
        String          fileDir = new String();
        File            file = null;
        chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        file = new File(project.getProperty(AntProject.INPUT_DIR));
        if (!file.isAbsolute()) {
            file = new File(project.getWorkingPath(), file.getPath());
        }
        chooser.setCurrentDirectory(file);
        chooser.setDialogTitle(res.getString("chooser_InputRoot_DialogTitle"));
        chooser.setApproveButtonText(res.getString("OK"));
        int v = chooser.showOpenDialog(this);

        this.requestFocus();
        jButtonBrowse.requestFocus();
        if (v == JFileChooser.APPROVE_OPTION) {
            if (!(chooser.getCurrentDirectory() == null)) {
                fileDir = chooser.getSelectedFile().toString();
                jTextFieldRoot.setText(fileDir);
                project.setProperty(AntProject.INPUT_DIR, fileDir);
                this.setNodes(project.getAllInput()); //Reload files from new input directory
            }
        }
        chooser.removeAll();
        chooser = null;
    }


    private class LocalCheckListener implements ActionListener {
        public void actionPerformed(ActionEvent event) {
            Object source = event.getSource();

            if (source == jCheckFullPath) {
                
                fillLists();
            }
        }

    }

    private class LocalListNode {
        private String full = new String();

        public LocalListNode(String fullName) {
            full = fullName;
        }

        public String toString() {
            String s = full;

            if (!jCheckFullPath.isSelected()) {
                File f = new File(full);

                s = f.getName();
            }
            return s;
        }

        public String getFullname() {
            return full;
        }

    }
}

