package org.enhydra.kelp.ant.deployer;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

//AddInCore
import org.enhydra.kelp.common.AbstractTool;
import org.enhydra.kelp.common.event.SelectionPanelEvent;
import org.enhydra.kelp.common.event.SelectionPanelListener;
import org.enhydra.kelp.common.event.WriteListener;
import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.common.node.OtterFileNode;
import org.enhydra.kelp.common.swing.AddinInnerPanel;
//import org.enhydra.kelp.common.properties.XMLCProjectPropertyPanel;
//import org.enhydra.kelp.common.xmlc.XMLCButtonPanel;
//import org.enhydra.kelp.common.xmlc.XMLCButtonListener;


//AddInAnt
import org.enhydra.kelp.ant.node.AntProject;
import org.enhydra.kelp.ant.swing.HTMLViewer;
//import org.enhydra.kelp.ant.xmlc.AntXMLCBuilder;


//ToolBox
import org.enhydra.tool.common.PathHandle;
import org.enhydra.tool.common.InnerPanel;
import org.enhydra.tool.common.SwingUtil;
import org.enhydra.tool.common.ButtonPanel;
import org.enhydra.tool.common.event.FirstFocusEvent;
import org.enhydra.tool.common.event.FirstFocusListener;

// Standard imports
import java.io.File;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.event.ActionListener;
import java.lang.ref.WeakReference;
import java.net.URL;
import java.util.ResourceBundle;
/**
 * <p>Title: </p>
 * <p>Description: Deploy tool use AntProject for read,write properties and
 * AntDeployBuilder for running Deployer. </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Damir Milovic
 * @version 1.0
 */

public class AntDeployTool extends AbstractTool
                         implements FirstFocusListener {

    static ResourceBundle            addinRes =
        ResourceBundle.getBundle("org.enhydra.kelp.common.Res");
    private AntDeployInnerPanel           innerPanel = null;
//    private XMLCButtonPanel          buttonPanel = null;
    private AntDeployButtonPanel buttonPanel = null;
    private WeakReference            compileRef = null;

  public AntDeployTool() {
    super();
    innerPanel = new AntDeployInnerPanel();
    buttonPanel = new AntDeployButtonPanel();
    innerPanel.addFirstFocusListener(this);
  }
  public static void main(String[] args) {
        SwingUtil.setLookAndFeelToSystem();
        AntDeployTool tool = null;
        AntProject project = null;
        if(args.length > 0){
          // check path
            File root = new File(args[0]);
            if(!root.exists()){
              System.err.println("ERROR: directory'"+args[0]+"' don't exist!");
              return;
            }
            try {
                project = new AntProject(args[0]);
            }
            catch (Exception ex) {
                ex.printStackTrace();
                return;
            }

        }else{
            return;
          //FIXME TODO get current directory
        }

        tool = new AntDeployTool();
        tool.setProject(project); //DACHA
        tool.showDialog(new Frame());
        return;
  }
  /**
   * Override
   */
  public void build() {
    ((AntDeployInnerPanel)getInnerPanel()).selectOutputTab();
    ((AntDeployInnerPanel)getInnerPanel()).save();
    ((AntDeployInnerPanel)getInnerPanel()).clearOutput();
    buildImpl();
  }

  private void buildImpl() {
    AntDeployBuilder builder = new AntDeployBuilder(((AntDeployInnerPanel)getInnerPanel()).getWriteListeners());
    builder.setProject(getProject());
    builder.build();
  }

    public static final String getDefaultTitle() {
        return "Deployer";
    }

    // implements AbstractTool
    public String getTitle() {
        return AntDeployTool.getDefaultTitle();
    }

    // implements AbstractTool
    public InnerPanel getInnerPanel() {
        return innerPanel;
    }

    // implements AbstractTool
    public ButtonPanel getButtonPanel() {
        return buttonPanel;
    }

    public ActionListener createButtonListener() {
        return (new AntDeployButtonListener(this));
    }

    // overrides AbstractTool
    public void setProject(OtterProject project) {
        super.setProject(project);
//        setNodes(project.getAllDocuments());
    }

    // overrides AbstractTool
    public void clearAll() {
        super.clearAll();
       innerPanel.removeFirstFocusListener(this);
        if (compileRef != null) {
            compileRef.clear();
        }
        innerPanel = null;
        buttonPanel = null;
        compileRef = null;
    }

    // implements FirstFocusListener
    public void onFirstFocus(FirstFocusEvent event) {
        /** @todo  */
    }
    
	public void showHelp(Dialog parent){
    	URL helpURL = this.getClass().getClassLoader().getResource("using_ant_kelp.html");
		HTMLViewer.createAndShow(parent, "Kelp Help", helpURL);

    }
    // implements org.enhydra.kelp.common.tool.AbstractTool
    protected String getProgressTitle() {
        return addinRes.getString("Deployment_Progress");
    }

    // implements org.enhydra.kelp.common.tool.AbstractTool
    protected AddinInnerPanel getPropertyPanel() {
        return innerPanel;
    }

    protected void back() {
      innerPanel.back();
    }

    protected void next() {
      innerPanel.next();
    }
}
