package org.enhydra.kelp.ant.node;
//Kelp imports
import org.enhydra.kelp.common.node.OtterFileNode;
import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.common.node.OtterNode;
import org.enhydra.kelp.common.node.PropertyKeys;
import org.enhydra.kelp.common.PropUtil;
// ToolBox imports
import org.enhydra.tool.common.PathHandle;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Damir Milovic
 * @version 1.0
 */

public class AntFileNode implements OtterFileNode {

  protected Throwable exception = null;
  protected OtterNode otterNode = null;
  protected String path = null;
  protected OtterProject project = null;
  //FIXME spesific properties for now are holds here (should be paged into unique file)
  protected String selected = "false";

  public AntFileNode(OtterNode node) {
    otterNode = node;
    project = otterNode.getProject();
  }
  public AntFileNode(OtterNode node,String filePath) {
    this(node);
    path = filePath;
  }
  public String getFilePath() {
    return path;
  }
  public String getProperty(String property) {
    if(property.equalsIgnoreCase(PropertyKeys.NAME_SELECTED))
      return selected;  //FIXME see the Definition of selected
    else
      return project.getProperty(property); //The OtterProject (AntProjet) holds all properties
  }
  public void setProperty(String property, String value) {
    if(property.equalsIgnoreCase(PropertyKeys.NAME_SELECTED))
      selected = value;
    else
      project.setProperty(property,value);  //Let the OtterProject (AntProjet) holds all properties
  }
  public void setProperty(String property, int value) {
    project.setProperty(property,value);  //Let the OtterProject (AntProjet) holds all properties
  }
  public Object getNativeNode() {
    return null;
  }
  public void setNativeNode(Object o) {
    /**@todo: Implement this org.enhydra.kelp.common.node.OtterNode method*/
    throw new java.lang.UnsupportedOperationException("Method setNativeNode() not yet implemented.");
  }
  public OtterProject getProject() {
    return project;
  }
  public OtterNode getParent() {
    if(otterNode instanceof OtterProject)
      return otterNode;
    else
      return otterNode.getParent();
  }
  public String getXMLCOptionFilePath() {
    return project.getXMLCOptionFilePath(); //The OtterProject (AntProjet) holds all properties
  }
  public void setXMLCOptionFilePath(String n) {
    project.setXMLCOptionFilePath(n); //Let the OtterProject (AntProjet) holds all properties
  }
  public String getXMLCParameters() {
    return project.getXMLCParameters(); //...
  }
  public void setXMLCParameters(String p) {
    project.setXMLCParameters(p);
  }
  public boolean isSelected() {
    String in = getProperty(PropertyKeys.NAME_SELECTED);
    return PropUtil.stringToBoolean(in, false);
  }
  public void setSelected(boolean b) {
    setProperty(PropertyKeys.NAME_SELECTED, PropUtil.booleanToString(b));
  }
  /**
   * Save Exception information for reporting. This lets exceptions from
   * multiple nodes to be reported in a batch.
   *
   * @param e
   * An exception that occured while invoking XMLC.
   */
  public void setException(Throwable e) {
    exception = e;
  }

  /**
   * Get an exception that occured when invoking XMLC. Null if the node
   * has not been compiled or was compiled without error.
   */
  public Throwable getException() {
      return exception;
  }
  public void save() {
    //FIXME
    System.out.println("AntFileNode path="+path+" save()");
  }

}