package org.enhydra.kelp.ant.xmlc;
//Kelp
import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.common.Constants;

import org.enhydra.kelp.ant.node.AntProject;
import org.enhydra.kelp.ant.xmlc.AntXMLCParamViewer;

//ToolBox
import org.enhydra.tool.common.DialogPanel;
import org.enhydra.tool.common.ExtensionFilter;
import org.enhydra.tool.common.PathHandle;

import org.enhydra.tool.swing.layout.*;

//JDK
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.ResourceBundle;
import java.io.File;
//import com.borland.jbcl.layout.*;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Damir Milovic
 * @version 1.0
 */

public class AntXMLCOptionsPanel extends JPanel {

    static ResourceBundle res = ResourceBundle.getBundle("org.enhydra.kelp.common.Res");

    XYLayout xYLayout1 = new XYLayout();
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    XYLayout xYLayout2 = new XYLayout();
    XYLayout xYLayout3 = new XYLayout();
    TitledBorder titledBorder1;
    TitledBorder titledBorder2;
    JLabel jLabel1 = new JLabel();
    JTextField jTextPackage = new JTextField();
    JButton jButtonDefault = new JButton();
    JLabel jLabel2 = new JLabel();
    JTextField jTextOptionFile = new JTextField();
    JButton jButtonEdit = new JButton();
    JButton jButtonBrowse = new JButton();

//    LocalButtonListener buttonListener = null;
    AntProject project = null;
    JPanel jPanel3 = new JPanel();
    JCheckBox jCheckBoxInvoke = new JCheckBox();
    XYLayout xYLayout4 = new XYLayout();
    JCheckBox jCheckBoxVerbose = new JCheckBox();

    public AntXMLCOptionsPanel() {
        try {
            jbInit();
            pmInit();
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }
    void jbInit() throws Exception {
        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"Mappings");
        titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)),"XMLC Options");
        this.setLayout(xYLayout1);
        jPanel1.setLayout(xYLayout2);
        jPanel2.setLayout(xYLayout3);
        jPanel1.setBorder(titledBorder1);
        jPanel2.setBorder(titledBorder2);
        jLabel1.setText(res.getString("Package"));
        jButtonDefault.setText(res.getString("Default"));
        jButtonDefault.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonDefault_actionPerformed(e);
            }
        });
        jLabel2.setText(res.getString("Option_file"));
        jButtonEdit.setText(res.getString("Edit"));
        jButtonEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonEdit_actionPerformed(e);
            }
        });
        jButtonBrowse.setText(res.getString("Browse"));
        jButtonBrowse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jButtonBrowse_actionPerformed(e);
            }
        });
        xYLayout1.setWidth(520);
        xYLayout1.setHeight(302);
        jTextOptionFile.setBackground(SystemColor.inactiveCaptionText);
        jTextOptionFile.setEditable(false);
        jPanel3.setLayout(xYLayout4);
        jCheckBoxInvoke.setText(res.getString("XMLC_Invoke_make"));
        jCheckBoxInvoke.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jCheckBoxInvoke_actionPerformed(e);
            }
        });
        jCheckBoxVerbose.setText(res.getString("Verbose_output"));
        jCheckBoxVerbose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jCheckBoxVerbose_actionPerformed(e);
            }
        });
        jTextPackage.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(FocusEvent e) {
                jTextPackage_focusLost(e);
            }
        });

        jPanel1.add(jTextPackage,     new XYConstraints(63, 13, 357, 23));
        jPanel1.add(jLabel1, new XYConstraints(4, 13, 59, 20));
        jPanel1.add(jButtonDefault,      new XYConstraints(424, 11, -1, -1));
        this.add(jPanel3,                     new XYConstraints(6, 16, 509, 106));
        jPanel2.add(jLabel2, new XYConstraints(3, 15, -1, -1));
        jPanel2.add(jTextOptionFile,   new XYConstraints(63, 13, 278, 25));
        jPanel2.add(jButtonBrowse,    new XYConstraints(410, 13, 88, -1));
        jPanel2.add(jButtonEdit,  new XYConstraints(343, 13, -1, -1));
        this.add(jPanel1,                  new XYConstraints(6, 127, 509, 76));
        jPanel3.add(jCheckBoxVerbose, new XYConstraints(6, 52, 151, 21));
        jPanel3.add(jCheckBoxInvoke, new XYConstraints(6, 14, -1, -1));
        this.add(jPanel2,             new XYConstraints(6, 208, 509, 86));
    }
    private void pmInit() {
        //textCommandLine.setText(new String());
        //buttonListener = new LocalButtonListener();
        //jButtonBrowse.addActionListener(buttonListener);
        //jButtonDefault.addActionListener(buttonListener);
        //jButtonEdit.addActionListener(buttonListener);
    }

    public void setProject(OtterProject otterProject){
        if(otterProject instanceof AntProject) {
            project = (AntProject) otterProject;
            initOptions();
        }
        else
            System.err.println("DEBUG project must be AntProject");//FIXME throw Exception
    }

    private void initOptions() {
        String invoke = project.getProperty(AntProject.XMLC_INVOKE);
        if(invoke != null)
            jCheckBoxInvoke.setSelected(invoke.equalsIgnoreCase("true"));
        String verbose = project.getProperty(AntProject.XMLC_VERBOSE);
        if(verbose != null)
            jCheckBoxVerbose.setSelected(verbose.equalsIgnoreCase("true"));
        jTextPackage.setText(project.getProperty(AntProject.XMLC_PACKAGE_NAME));
        jTextOptionFile.setText(project.getProperty(AntProject.XMLC_OPTIONS_FILE));
    }

    public OtterProject getProject(){
        return (OtterProject) project;
    }

    private void editParameters() {
        String[]           params = new String[0];
        AntXMLCParamViewer viewer = null;

        viewer = new AntXMLCParamViewer();
        params = project.getXMLCOptionsFileParams();
        viewer.setParameters(params);
        viewer.setOwner((Dialog) getTopLevelAncestor());
        if (viewer.showDialog() == DialogPanel.OK_OPTION) {
            params = viewer.getParameters();
            project.setXMLCOptionsFileParams(params);
        }
    }
     private void browseForFile() {
        JFileChooser    chooser;
        ExtensionFilter filter;
        File            file;
        String          fileDir = new String();
        String          fileName = new String();
        String          filePath = new String();

        filter = new ExtensionFilter();
        filter.addExtension(Constants.TYPE_XMLC);
        filter.setDescriptionTitle(res.getString("filter_DescriptionTitle"));
        chooser = new JFileChooser();
        if (jTextOptionFile.getText().trim().length() > 0) {
            chooser.setCurrentDirectory(
                new File(project.getProperty(AntProject.RESOURCES_DIR)));
        } else {
            /*
            PathHandle ph = null;

            if (node instanceof OtterFileNode) {
               OtterFileNode fileNode = (OtterFileNode) node;
                ph = PathHandle.createPathHandle(fileNode.getFilePath());
                if (ph.isEmpty()) {
                  ph = null;
                } else {
                  ph = ph.getParent();
                }
            }

            if (ph == null) {
                ph = PathHandle.createPathHandle(node.getProject().getRootPath());
            }
            */
            PathHandle ph = PathHandle.createPathHandle(getProject().getWorkingPath());
            chooser.setCurrentDirectory(ph.getFile());
        }
        chooser.setFileFilter(filter);
        chooser.setDialogTitle(res.getString("chooser_DialogTitle"));
        chooser.setApproveButtonText(res.getString("OK"));
        int v = chooser.showOpenDialog(this);

        this.requestFocus();
        jButtonBrowse.requestFocus();
        if (v == JFileChooser.APPROVE_OPTION) {
            if (chooser.getSelectedFile() == null
                    || (!chooser.getSelectedFile().isFile())) {
                jTextOptionFile.setText(new String());
            } else {
                fileDir = chooser.getCurrentDirectory().toString();
                fileDir = stripSlash(fileDir);
                fileName = chooser.getSelectedFile().getName();
                filePath = fileDir + File.separator + fileName;
                jTextOptionFile.setText(filePath);
                project.setProperty(AntProject.XMLC_OPTIONS_FILE, filePath);
            }
        }
        chooser.removeAll();
        chooser = null;
    }

    private String stripSlash(String dir) {
        String stripped = new String(dir);

        if (dir != null) {
            if (dir.length() > 0) {
                if (dir.endsWith(File.separator)) {
                    stripped = dir.substring(0, dir.length() - 1);
                }
            }
        }
        return stripped;
    }
/*
    private class LocalButtonListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            Object source = e.getSource();

            if (source == jButtonBrowse) {
               browseForFile();
            } else if (source == jButtonDefault) {
               // setDefaultPackage();
            } else if (source == jButtonEdit) {
                editParameters();
            }
        }

    }
*/
    void jCheckBoxInvoke_actionPerformed(ActionEvent e) {
        String invoke = "false";
        if(jCheckBoxInvoke.isSelected())
            invoke = "true";
        project.setProperty(AntProject.XMLC_INVOKE, invoke);
    }

    void jCheckBoxVerbose_actionPerformed(ActionEvent e) {
        String verbose = "false";
        if(jCheckBoxVerbose.isSelected())
            verbose = "true";
        project.setProperty(AntProject.XMLC_VERBOSE, verbose);
    }

    void jButtonDefault_actionPerformed(ActionEvent e) {
        //get default package name
        jTextPackage.setText(project.getProperty(AntProject.XMLC_DEFAULT_PACKAGE));
        project.setProperty(AntProject.XMLC_PACKAGE_NAME, jTextPackage.getText());
    }

    void jButtonEdit_actionPerformed(ActionEvent e) {
        editParameters();
    }

    void jButtonBrowse_actionPerformed(ActionEvent e) {
        browseForFile();
    }

    void jTextPackage_focusLost(FocusEvent e) {
        project.setProperty(AntProject.XMLC_PACKAGE_NAME, jTextPackage.getText());
    }
}