
/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.tool.archive;

// Toolbox Imports
import org.enhydra.tool.common.FileUtil;
import org.enhydra.tool.common.PathHandle;
import org.enhydra.tool.common.ResUtil;

// Standard imports
import java.io.File;
import java.io.FileFilter;
import java.util.ResourceBundle;

//
public class EjbPlan extends JarPlan {

    //
    private boolean createClient = true;

    public EjbPlan() {
        super();
        Descriptor[] initDD = new Descriptor[2];

        initDD[0] = new Descriptor(true, Descriptor.EJB);
        initDD[1] = new Descriptor(false, Descriptor.JONAS_EJB);
        setDescriptors(initDD);
    }

    public boolean isCreateClient() {
        return createClient;
    }

    public void setCreateClient(boolean b) {
        createClient = b;
    }

    public boolean equals(Object comp) {
        EjbPlan plan = null;
        boolean equal = false;

        if (comp instanceof EjbPlan) {
            plan = (EjbPlan) comp;
            equal = super.equals(comp);
        }
        if (equal) {
            if (!(plan.isCreateClient() == isCreateClient())) {
                equal = false;
            }
        }
        return equal;
    }

}
