
package org.enhydra.tool.archive.xml;

//
import org.w3c.dom.Element;

//
public class WarDescriptorHandler extends AbstractDescriptorHandler {
    private final String SESSION_CONFIG = "session-config";
    private final String TIMEOUT_NAME = "session-timeout";
    private final String TIMEOUT_VALUE = "30";
    private final String DESC_NAME = "description";
    private final String DESC_VALUE = "no description";
    private final String PUBLIC_ID =
        "-//Sun Microsystems, Inc.//DTD Web Application 2.2//EN";
    private final String SYSTEM_ID =
        "http://java.sun.com/j2ee/dtds/web-app_2.2.dtd";

    //
    public static void main(String[] args) {
        WarDescriptorHandler prep = new WarDescriptorHandler();

        prep.setSource("d:/test/simple/test2.xml");
        prep.setOutStream(System.out);
        try {
            prep.prep();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //
    protected String getPublicID() {
        return PUBLIC_ID;
    }

    protected String getSystemID() {
        return SYSTEM_ID;
    }

    protected void prepElements() {
        prepDescription();
        prepTimeout();
    }

    //
    private void prepDescription() {
        Element desc = null;

        desc = lookup(getDoc().getDocumentElement(), DESC_NAME);
        if (desc == null) {
            desc = getDoc().createElement(DESC_NAME);
            desc.appendChild(getDoc().createTextNode(DESC_VALUE));
            getDoc().getDocumentElement().appendChild(desc);
        }
    }

    private void prepTimeout() {
        Element config = null;
        Element timeout = null;

        config = lookup(getDoc().getDocumentElement(), SESSION_CONFIG);
        if (config == null) {
            config = getDoc().createElement(SESSION_CONFIG);
            getDoc().getDocumentElement().appendChild(config);
        }
        timeout = lookup(config, TIMEOUT_NAME);
        if (timeout == null) {
            timeout = getDoc().createElement(TIMEOUT_NAME);
            timeout.appendChild(getDoc().createTextNode(TIMEOUT_VALUE));
            config.appendChild(timeout);
        }
    }

}
