package org.enhydra.kelp.jbuilder.actions;

import com.borland.primetime.ide.Browser;
import com.borland.primetime.ide.BrowserAction;
import javax.swing.AbstractAction;
import org.enhydra.kelp.ant.deployer.AntDeployTool;
import com.borland.jbuilder.node.JBProject;
import com.borland.primetime.vfs.Filesystem;
import com.borland.primetime.vfs.VFS;
import com.borland.primetime.vfs.Url;
import com.borland.primetime.node.FileNode;
import java.io.File;
import com.borland.primetime.node.FolderNode;
import com.borland.primetime.node.Node;
import com.borland.primetime.node.LightweightNode;
import org.enhydra.kelp.ant.node.AntProject;
import org.enhydra.kelp.jbuilder.node.NodeUtil;

public class DeployerAction extends BrowserAction
{

  private JBProject project;

  public DeployerAction(String s, char c) {
    super(s, c);
  }

  public void actionPerformed(Browser browser) {
    String prjPath = null;
    Url url;
    project = (JBProject) browser.getActiveProject();
    prjPath = project.getProjectPath().getFullName();
    AntProject antProject = null;
    try {
      antProject = new AntProject(prjPath);
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    AntDeployTool.main(new String[] {prjPath});

    url = new Url(new File(antProject.getProperty(AntProject.OUTPUT_DIR)));
    if (url.getFileObject().exists()) {
      try {
        NodeUtil.doAddFolders(project, project, url);
      }
      catch (Exception ex) {
        ex.printStackTrace();
      }
      browser.getActiveProject().refresh();
    }
  }

  /**
   * Enables deploy action if current project exists and if it is JBProject type
   * and if exist builder.xml file in the project
   *
   * @param browser
   */
  public void update(Browser browser) {
    if (browser.getActiveProject() != null) {
      project = (JBProject)browser.getActiveProject();
      setEnabled( (project instanceof JBProject) &&
                  (project.getProperty("enhydra.project", "false")
                    .equalsIgnoreCase("true")) );
    } else {
      setEnabled(false);
    }
  }
}