
package org.enhydra.tool.archive.wizard;

//
import org.enhydra.tool.archive.ArchiveException;
import org.enhydra.tool.archive.JarPlan;
import org.enhydra.tool.archive.WarPlan;
import org.enhydra.tool.common.PathHandle;
//
import java.awt.*;
import java.beans.Beans;
import java.io.File;
import javax.swing.*;


//
public class ContentPanel extends ArchivePanel {
    private BorderLayout layoutMain = null;
    private TwoColumnFileSelector selectorPanel = null;

    public ContentPanel() {
        try {
            jbInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void validatePlan() throws ArchiveException {
        selectorPanel.validatePlan();
    }

    public void readPlan(JarPlan plan) throws ArchiveException {
      WarPlan wp = (WarPlan) plan;
      selectorPanel.setRoot(wp.getContentRoot());
      selectorPanel.setSelections(wp.getContentFileArray());
    }

    public void writePlan(JarPlan plan) throws ArchiveException {
      WarPlan wp = (WarPlan) plan;
      validatePlan();
      wp.setContentRoot(selectorPanel.getRoot());
      wp.setContentFiles(selectorPanel.getSelections());
    }

    public String getPageTitle() {
      return "Content";
    }

    protected void preparePanel() {
      if (selectorPanel.getRootFile() == null) {
        StringBuffer buf = new StringBuffer();
        PathHandle path = null;
        buf.append(getWorkingRoot());
        buf.append(File.separator);
        buf.append("output/content");
        path = PathHandle.createPathHandle(buf.toString());
        if (path.isDirectory()) {
          selectorPanel.setDefaultSelect(true);
          selectorPanel.setRoot(path.getPath());
        }
      }
    }

    public String getInstructions() {
      StringBuffer buf = new StringBuffer();
      buf.append("Select files to include in content");
      return buf.toString();
    }



    private void jbInit() throws Exception {
        layoutMain =
            (BorderLayout) Beans.instantiate(getClass().getClassLoader(),
                                             BorderLayout.class.getName());
        selectorPanel =
            (TwoColumnFileSelector) Beans.instantiate(getClass().getClassLoader(),
                                             TwoColumnFileSelector.class.getName());

        this.setLayout(layoutMain);
        this.add(selectorPanel, BorderLayout.CENTER);
    }



}
