
/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.tool.common.wizard;

// Standard imports
import javax.swing.JPanel;
import java.io.File;

/**
 * This class defines the type of panel you can add to an
 * OpenTool's BasicWizardPage or an CodeGenPage. Do to limitations
 * in the JBuilder UI designer, this class and some of it's methods
 * are not left as abstract.
 */
public class TBWizardPanel extends JPanel {

    /**
     * Create an ToolBoxWizardPanel for use in an OpenTool BasicWizardPage
     * or an ToolBoxWizardPage.
     */
    public TBWizardPanel() {}

    /**
     * Get the title to use on the current page. Override this
     * to set a custom title.
     *
     * @return
     * A string to place at the top of a CodeGen wizard panel.
     */
    public String getPageTitle() {
        return "PAGE TITLE";    // nores
    }

    /**
     * Get the instructions for entering option values for the
     * current page. Override this to set instructions.
     *
     * @return
     * A string to place below the page title. The string will
     * wrap if too wide to fit in text control.
     */
    public String getInstructions() {
        return new String();
    }

}
